import logger from "./inc/log";
import { read, cfg } from "./inc/cfg";
import { default as config } from "../cfg/config.json";

import triggers from "./inc/trigger";
import events from "./inc/events";

import cuffeo from "cuffeo";

(async () => {
  await read(); // read and parse config from database

  const self = {
    _trigger: new Map(),
    trigger: function trigger(args) {
      this.call = args.call;
      this.help = args.help || false;
      this.level = args.level || 0;
      this.active = args.hasOwnProperty("active") ? args.active : true;
      this.set = args.set || "all"; // uwe, nxy, f0ck, all
      this.clients = args.clients || [ "irc", "tg" ];
      this.f = args.f;
    },
    bot: new cuffeo(config.clients)
  };

  triggers.forEach(mod => mod(self));
  events.forEach(event => event(self));
})();
