import {default as fetch, cookieJar, Cookie} from "flumm-fetch-cookies";

const apis = {
  reverse: "https://pr0gramm.com/api/items/get?flags=15&tags=!p:",
  list: "https://pr0gramm.com/api/items/get?flags=15&id=",
  item: "https://pr0gramm.com/api/items/info?flags=15&itemId="
};

const color = new Proxy({}, {
  get: (_, prop) => s => `[color=${prop}]${s}[/color]`
});

const flags = {
  1: color.green("sfw"),
  2: color.magenta("nsfw"),
  4: color.red("nsfl"),
  8: color.blue("nsfp")
};

const regex = {
  normal: /pr0gramm\.com\/.+\/(\d+)(?:\s|$)/i,
  direct: /(full|img|vid)\.pr0gramm\.com\/((?:\d+){4}\/(?:\d+){2}(?:\/(?:\d+){2})?\/(?:\w{1,20})\.(gif|png|jpg|mp4))/i
};

/*fetch("https://pr0gramm.com/api/user/login", {
  method: "POST",
  body: {
    username: "",
    password: ""
  }
}).then(res => {
  console.log("pr0gag: " + (res.body.statusCode === 200 ? "login successful" : "login failed. http status " + res.body.statusCode));
  return res.json();
}).then(console.log);*/

export default bot => {
  bot._trigger.set("pr0gag", new bot.trigger({
    call: /pr0gramm\.com\/.+\/.+/i,
    set: "uwe",
    f: async e => {
      let reply;
      try {
        let matches, id;
        if(matches = e.message.match(regex.direct)) {
          const path = matches[1] === "full" && matches[3] === "png"
                    ? matches[2].slice(0, -3) + "jpg"
                    : matches[2];
          const response = await (await fetch(apis.reverse + path)).json();
          if(response.error || !response.items.length)
            throw "reverse lookup error";
          id = response.items[0].id;
        }
        else if(matches = e.message.match(regex.normal))
          id = matches[1];
        else
          return;

        let [list, info] = await Promise.all([
          fetch(apis.list + id),
          fetch(apis.item + id)
        ].map(async request => (await request).json()));

        list = list.items.filter(item => item.id == id)[0]; // ja, == ist hier ein muss!
        if(!list || !info || !Array.isArray(info.tags) || !Array.isArray(info.comments))
          throw "item lookup error";

        const toptags = info.tags
          .sort((a, b) => b.confidence - a.confidence)
          .slice(0, 3)
          .map(tag => tag.tag)
          .join(", ");

        const voteRatio = list.up / (list.up + list.down);

        const voteRatioColors = [
            "red",
            "brown",
            "orange",
            "yellow",
            "green",
            "lightgreen",
        ];

        const voteRatioColor = voteRatioColors[~~Math.min(voteRatio * voteRatioColors.length, voteRatioColors.length - 1)];

        reply = [
          "https://pr0gramm.com/" + (list.promoted ? "top" : "new") + "/" + id,
          `${list.up - list.down} (${color.green(list.up)} / ${color.red(list.down)} = ${color[voteRatioColor]((voteRatio * 100).toFixed(1))}${color.magenta("%")})`,
          "user: " + list.user,
          "comments: " + info.comments.length,
          `toptags: ${toptags} (${flags[list.flags]})`
        ].join(" - ");
      }
      catch(error) {
        reply = typeof error === "string" ? error : JSON.stringify(error);
      }
      finally {
        reply && e.reply(reply);
      }
    }
  }));
};
