import fetch from "flumm-fetch-cookies";
import { cfg } from "../../inc/cfg";
import { conds } from "./lib/wttr";

export default bot => {
  bot._trigger.set("wttr", new bot.trigger({
    call: /^\.wttr .*/i,
    set: "uwe",
    help: {
      text: "Gets the weather from wttr.in",
      usage: "[b].wttr[/b] [i]<location>[/i]"
    },
    clients: ["irc"],
    f: e => {
      //return e.reply("wttr.in saugt. Bitte .weather nutzen.");
      let args = e.message.trim().substring(6);
      let options = {
        headers: {
          'User-Agent': 'curl/7.43.0',
          'accept-language': 'de-DE,de'
        }
      };
      fetch(`http://wttr.in/${encodeURIComponent(args)}`, options)
        .then(res => res.text())
        .then(body => {
          let origbody = body;
          body = body
            .split("\u001b[38;5;226m").join("\x0308") // yellowlight
            .split("\u001b[38;5;154m").join("\x0303") // green
            .split("\u001b[38;5;118m").join("\x0303") // green
            .split("\u001b[38;5;190m").join("\x0309") // lime
            .split("\u001b[38;5;046m").join("\x0309") // lime
            .split("\u001b[38;5;048m").join("\x0309") // lime
            .split("\u001b[38;5;082m").join("\x0309") // lime
            .split("\u001b[38;5;047m").join("\x0309") // lime
            .split("\u001b[38;5;202m").join("\x0305") // red
            .split("\u001b[38;5;196m").join("\x0305") // red
            .split("\u001b[38;5;220m").join("\x0304") // orange to brown
            .split("\u001b[38;5;214m").join("\x0304") // orange to brown
            .split("\u001b[38;5;208m").join("\x0304") // orange to brown
            .split("\u001b[38;5;240;1m").join("\x0314") // darkgrey
            .split("\u001b[38;5;21;1m").join("\x0302") // blue
            .split("\u001b[38;5;21;25m").join("\x0302") // blue
            .split("\u001b[38;5;111;25m").join("\x0311") // lightblue
            .split("\u001b[38;5;111m").join("\x0311") // lightblue
            .split("\u001b[38;5;251m").join("\x0315") // lightgrey
            .split("\u001b[38;5;021m").join("\x0302") // arschkalt
            .split("\u001b[38;5;051m").join("\x0302") // arschkalt
            .split("\u001b[38;5;049m").join("\x0302") // arschkalt
            .split("\u001b[38;5;255;1m").join("\x0300") // white
            .split("\u001b[38;5;250m").join("\x0F") // yellow to white
            .split("\u001b[1m").join("\x0F") // normalize
            .split("\u001b[0m").join("\x0F") // normalize
            .split("\u000f").join("\x0F") // normalize
            .split("\u001b[38;5;228;5m").join("\x0F") // normalize
            .split("\u26a1").join(" ") // fick emoji
            .split("\n")
          if (origbody.match(/ERROR.*(location|Unbekannter)/i))
            return e.reply(body[0].replace("ERROR: ", ""));
          if (args.trim().match(/^moon/i))
            return e.reply("ob du behindert bist.");
          [body[0], body[2], body[3], body[4], body[5], body[6]].map(e.reply);
        }).catch(err => console.log(err));
    }
  }));

  bot._trigger.set("wttrnew", new bot.trigger({
    call: /^(\.|\/)w .*/i,
    set: "all",
    help: {
      text: "Gets the weather from OWM",
      usage: "[b].w[/b] [i]<location>[/i]"
    },
    f: e => {
      const loc = encodeURIComponent(e.message.trim().substring(3));
      const key = cfg.main.owm.val.key;
      const api = `http://api.openweathermap.org/data/2.5/weather?q=${loc}&appid=${key}&units=metric&lang=de`;

      fetch(api)
        .then(res => res.json())
        .then(res => {
          if(res.cod !== 200)
            return e.reply(res.message);
          let data = [];
          let icon = "";

          if(/^bremen/i.test(loc)) {
            const temp_min = (res.main.temp_min / Math.PI).toFixed(2);
            const temp_max = Math.sqrt(res.main.temp_max).toFixed(2);
            data = [
              "Gewitter mit Hagal",
              `${temp_min} * π bis ${temp_max}² °C`,
              `${[..."↓↙←↖↑↗→↘"][-~parseInt((res.wind.deg + 22) % 360 / 45)] || ""} ${res.wind.speed} km/h`,
              "Mathe macht Spaß,",
              "wenn's vorbei ist."
            ];
            icon = conds(202);
          }
          else {
            data = [
              res.weather[0].description,
              `${res.main.temp_min} - ${res.main.temp_max} °C`,
              `${[..."↓↙←↖↑↗→↘"][-~parseInt((res.wind.deg + 22) % 360 / 45)] || ""} ${res.wind.speed} km/h`,
              "",
              ""
            ];
            icon = conds(res.weather[0].id);
          }

          e.reply(`Wetterbericht für: ${res.name}, ${res.sys.country}\n${[...Array(5)].map((_, i) => `${icon[i].padEnd(15)} ${data[i]}`).join("\n")}`);
        }).catch(err => console.log(err));
      }
    }));

  bot._trigger.set("weather", new bot.trigger({
    call: /^(\.|\/)weather .*/i,
    set: "all",
    help: {
      text: "Gets the weather from OWM",
      usage: "[b].weather[/b] [i]<location>[/i]"
    },
    f: e => {
      const loc = encodeURIComponent(e.message.trim().substring(9));
      const key = cfg.main.owm.val.key;
      const api = `http://api.openweathermap.org/data/2.5/weather?q=${loc}&appid=${key}&units=metric&lang=de`;

      fetch(api)
        .then(res => res.json())
        .then(res => {
          if(res.cod !== 200)
            return e.reply(res.message);
          if(/^bremen/i.test(loc)) {
            const temp = Math.sqrt(res.main.temp).toFixed(2);
            e.reply(
                `Bremen, DE: `
              + `${temp}² °C Schwere Gewitter mit Hagal und Sturzfluten, `
              + `${[..."↓↙←↖↑↗→↘"][-~parseInt((res.wind.deg + 22) % 360 / 45)] || ""} ${res.wind.speed} km/h`
            );
          }
          else {
            e.reply(
                `${res.name}, ${res.sys.country}: `
              + `${res.main.temp}°C ${res.weather[0].description}, `
              + `${[..."↓↙←↖↑↗→↘"][-~parseInt((res.wind.deg + 22) % 360 / 45)] || ""} ${res.wind.speed} km/h`
            );
          }
        }).catch(err => e.reply(err));
    }
  }));
};
